# B4R Library rConceptinetics - README Example DMXRESTServer WiFi

## Purpose
To control DMX lights from a desktop application sending commands to an Arduino DMX RESTful Server via HTTP.

## Concept
An ESP8266 LOLIN(WeMos) D1 R1 [ESP8266] runs a B4R program acting as an HTTP RESTful server (DMXServer).
The ESP8266 is connected to the Arduino MEGA and communicates via SoftSerial.
The Arduino MEGA + Arduino DMX shield runs an B4R program listening to DMX commands from the ESP8266 (DMXController).
The data sent from the ESP8266 is serialized and contains 2 object channel and value to control the LED light.

The RESTful server listens for commands send via HTTP GET requests from clients like B4J-App, Browser, Node-RED, Python.
The HTTP GET request arguments (must be in lowercase!):
* channel=1-512 (mandatory)
* value=0-255 (mandatory)
* disconnect=0 or 1 (optional, default 1 = disconnect after executing command)
The disconnect argument can be used to keep a connection until closed by the client,
else socket connection made, channel and value set and socket connection is closed.
```
http://dmx-controller-ip/channel=1-512&value=0-255&disconnect=0|1
```

**Example Browser HTTP GET Request**
Control an LED with address 1 and the 4 channels Dimmer-RED-GREEN-BLUE.
The address applies to the first channel as set on the LED:
The LED has on the back a digital display with 4 setting button which is set to DMX Mode d0001.

* Set channel 1 (Total Dimming) to full: http://dmx-controller-ip/channel=1&value=255
* Set channel 4 (Blue) to low value: http://dmx-controller-ip/channel=4&value=10

Note: The connection is disconnected (argument disconnect=1) after every command.

## Hardware
* 1x Arduino MEGA
* 1x CQRobot DMX Shield MAX485 for MCU
* 1x WeMos D1 R1 (ESP8266)
* 1x LED Mini Flat Par Light LSPA36RC (DMX512 with 3-7 channels)
* 1x Adam Hall Cables 3 STAR DMF 0600 DMX Cable 3-Pol XLR Female auf 3-Pol XLR male 6 m 
* 1x Adam Hall Connectors 3 STAR DMX T 3 XLR Cable 3-Pol woth 120OHM resistor

## Software
* B4R 4.0 - DMXServer ESP8266
* B4R 4.0 - DMXController Arduino MEGA
* B4R Additional Library rConceptinetics 0.5
* B4J 10.0 - DMXClient UI with CustomView SliderLevel to control a DMX channel value

## Wiring
**Arduino MEGA = ESP8266**
```
Pin 5v = 5v
Pin GND = GND
Pin 52 RX = D2 TX (Blue)
Pin 53 TX = D1 RX (Green)
```
**Notes**
ESP8266 B4R Program: Wenn running, the Arduino MEGA provides the ESP8266 with power & ground.

**Arduino MEGA = DMX Shield**
```
Pin 18 TX1 = 3 RX (Blue)
Pin 19 RX1 = 4 TX (Green)
```

## Notes
* For more information, see README.md of the rConceptinetics library.
* This HTTP RESTful server concept could also be used for other applications.
